sua.c File Reference
`#include <stdint.h>`
`#include <errno.h>`
`#include <unistd.h>`
`#include <string.h>`
`#include <osmocom/core/utils.h>`
`#include <osmocom/core/linuxlist.h>`
`#include <osmocom/core/write_queue.h>`
`#include <osmocom/core/logging.h>`
`#include <osmocom/core/timer.h>`
`#include <osmocom/core/socket.h>`
`#include <osmocom/core/fsm.h>`
`#include <osmocom/netif/stream.h>`
`#include <osmocom/sigtran/xua_msg.h>`
`#include <osmocom/sigtran/sccp_sap.h>`
`#include <osmocom/sigtran/protocol/mtp.h>`
`#include <osmocom/sigtran/protocol/sua.h>`
`#include <osmocom/sigtran/protocol/m3ua.h>`
`#include <osmocom/sigtran/osmo_ss7.h>`
`#include "xua_as_fsm.h"`
`#include "xua_asp_fsm.h"`
`#include "xua_internal.h"`
`#include "sccp_internal.h"`

## Macros

#define | CONNECTION_TIMER ( 1 * 60 * 100)
#define | TX_INACT_TIMER ( 7 * 60 * 100) /* RFC 3868 Ch. 8. */
#define | RX_INACT_TIMER (15 * 60 * 100) /* RFC 3868 Ch. 8. */
#define | RELEASE_TIMER ( 10 * 100)
#define | RELEASE_REP_TIMER ( 10 * 100)
#define | INT_TIMER ( 1 * 60 * 100)
#define | GUARD_TIMER (23 * 60 * 100)
#define | RESET_TIMER ( 10 * 100)
#define | SCCP_MSG_SIZE 2048
#define | SCCP_MSG_HEADROOM 512
#define | MAND_IES(msgt, ies) [msgt] = (ies)

## Functions

struct msgb * | sccp_msgb_alloc (const char *name)
static struct xua_msg * | sua_gen_error (uint32_t err_code)
static struct xua_msg * | sua_gen_error_msg (uint32_t err_code, struct msgb *msg)
static struct msgb * | sua_to_msg (struct xua_msg *xua)
static int | sua_tx_xua_asp (struct osmo_ss7_asp *asp, struct xua_msg *xua)
int | sua_tx_xua_as (struct osmo_ss7_as *as, struct xua_msg *xua)
| Send a given xUA message via a given SUA Application Server. More...
int | sua_parse_gt (struct osmo_sccp_gt *gt, const uint8_t *data, unsigned int datalen)
| Decode SUA Global Title according to RFC3868 Section 3.10.2.3. More...
int | sua_addr_parse_part (struct osmo_sccp_addr *out, const struct xua_msg_part *param)
| parse SCCP address from given xUA message part More...
int | sua_addr_parse (struct osmo_sccp_addr *out, struct xua_msg *xua, uint16_t iei)
| parse SCCP address from given xUA message IE More...
static int | sua_rx_cl (struct osmo_ss7_asp *asp, struct xua_msg *xua)
static int | sua_rx_co (struct osmo_ss7_asp *asp, struct xua_msg *xua)
static int | sua_rx_mgmt_err (struct osmo_ss7_asp *asp, struct xua_msg *xua)
static int | sua_rx_mgmt_ntfy (struct osmo_ss7_asp *asp, struct xua_msg *xua)
static int | sua_rx_mgmt (struct osmo_ss7_asp *asp, struct xua_msg *xua)
static int | sua_rx_asp (struct osmo_ss7_asp *asp, struct xua_msg *xua)
int | sua_rx_msg (struct osmo_ss7_asp *asp, struct msgb *msg)
| process SUA message received from socket More...

## Variables

static const struct value_string | sua_iei_names []
static const uint16_t | cldt_mand_ies []
static const uint16_t | cldr_mand_ies []
static const struct value_string | sua_cl_msgt_names []
static const struct xua_msg_class | msg_class_cl
static const uint16_t | codt_mand_ies []
static const uint16_t | coda_mand_ies []
static const uint16_t | core_mand_ies []
static const uint16_t | coak_mand_ies []
static const uint16_t | coref_mand_ies []
static const uint16_t | relre_mand_ies []
static const uint16_t | relco_mand_ies []
static const uint16_t | resre_mand_ies []
static const uint16_t | resco_mand_ies []
static const uint16_t | coerr_mand_ies []
static const uint16_t | coit_mand_ies []
static const struct value_string | sua_co_msgt_names []
static const struct xua_msg_class | msg_class_co
const struct xua_dialect | xua_dialect_sua
static const struct xua_msg_event_map | sua_aspxm_map []

## Macro Definition Documentation

## CONNECTION_TIMER

#define CONNECTION_TIMER ( 1 * 60 * 100)

## GUARD_TIMER

#define GUARD_TIMER (23 * 60 * 100)

## INT_TIMER

#define INT_TIMER ( 1 * 60 * 100)

## MAND_IES

#define MAND_IES | ( |  | msgt,
|  |  | ies
| ) |  | [msgt] = (ies)

## RELEASE_REP_TIMER

#define RELEASE_REP_TIMER ( 10 * 100)

## RELEASE_TIMER

#define RELEASE_TIMER ( 10 * 100)

## RESET_TIMER

#define RESET_TIMER ( 10 * 100)

## RX_INACT_TIMER

#define RX_INACT_TIMER (15 * 60 * 100) /* RFC 3868 Ch. 8. */

## SCCP_MSG_HEADROOM

#define SCCP_MSG_HEADROOM 512

Referenced by sccp_msgb_alloc().

## SCCP_MSG_SIZE

#define SCCP_MSG_SIZE 2048

Referenced by sccp_msgb_alloc().

## TX_INACT_TIMER

#define TX_INACT_TIMER ( 7 * 60 * 100) /* RFC 3868 Ch. 8. */

## Function Documentation

## sccp_msgb_alloc()

struct msgb* sccp_msgb_alloc | ( | const char * | name | ) |

References SCCP_MSG_HEADROOM, and SCCP_MSG_SIZE.

Referenced by osmo_sua_to_sccp(), sclc_rx_cldr(), and sclc_rx_cldt().

## sua_addr_parse()

int sua_addr_parse | ( | struct osmo_sccp_addr * | out,
|  | struct xua_msg * | xua,
|  | uint16_t | iei
| ) |  |

parse SCCP address from given xUA message IE

Parameters

  [out] | out | caller-allocated decoded SCCP address struct
  [in] | xua | xUA message
  [in] | iei | Information Element Identifier inside xua

Returns
  0 on success; negative on error

References sua_addr_parse_part(), and xua_msg_find_tag().

Referenced by gen_ret_msg(), patch_sccp_with_pc(), sccp_find_user(), sccp_scrc_rx_sclc_msg(), sccp_scrc_rx_scoc_conn_msg(), sclc_rx_cldr(), sclc_rx_cldt(), scoc_fsm_idle(), scrc_rx_mtp_xfer_ind_xua(), and scu_gen_encode_and_send().

## sua_addr_parse_part()

int sua_addr_parse_part | ( | struct osmo_sccp_addr * | out,
|  | const struct xua_msg_part * | param
| ) |  |

parse SCCP address from given xUA message part

Parameters

  [out] | out | caller-allocated decoded SCCP address struct
  [in] | param | xUA message part containing address

Returns
  0 on success; negative on error

References xua_msg_part::dat, osmo_sccp_addr::gt, osmo_sccp_addr::ip, xua_msg_part::len, xua_parameter_hdr::len, OSMO_SCCP_ADDR_T_GT, OSMO_SCCP_ADDR_T_IPv4, OSMO_SCCP_ADDR_T_PC, OSMO_SCCP_ADDR_T_SSN, OSMO_SCCP_RI_GT, OSMO_SCCP_RI_SSN_IP, OSMO_SCCP_RI_SSN_PC, osmo_sccp_addr::pc, osmo_sccp_addr::presence, osmo_sccp_addr::ri, osmo_sccp_addr::ssn, SUA_IEI_GT, SUA_IEI_IPv4, SUA_IEI_PC, SUA_IEI_SSN, sua_parse_gt(), SUA_RI_GT, SUA_RI_HOST, SUA_RI_SSN_IP, SUA_RI_SSN_PC, xua_msg_part::tag, xua_parameter_hdr::tag, and osmo_sccp_addr::v4.

Referenced by sua_addr_parse(), and sua_addr_to_sccp().

## sua_gen_error()

static struct xua_msg* sua_gen_error | ( | uint32_t | err_code | ) |

static

References xua_msg::hdr, SUA_IEI_ERR_CODE, SUA_MGMT_ERR, SUA_MSGC_MGMT, SUA_VERSION, xua_common_hdr::version, XUA_HDR, xua_msg_add_u32(), and xua_msg_alloc().

Referenced by sua_gen_error_msg().

## sua_gen_error_msg()

static struct xua_msg* sua_gen_error_msg | ( | uint32_t | err_code,
|  | struct msgb * | msg
| ) |  |

static

References sua_gen_error(), SUA_IEI_DIAG_INFO, and xua_msg_add_data().

Referenced by sua_rx_msg().

## sua_parse_gt()

int sua_parse_gt | ( | struct osmo_sccp_gt * | gt,
|  | const uint8_t * | data,
|  | unsigned int | datalen
| ) |  |

Decode SUA Global Title according to RFC3868 Section 3.10.2.3.

Parameters

  [out] | gt | User-allocated structure for decoded output
  [in] | data | binary-encoded data
  [in] | datalen | length of data in octets

References osmo_sccp_gt::digits, osmo_sccp_gt::gti, osmo_sccp_gt::nai, osmo_sccp_gt::npi, and osmo_sccp_gt::tt.

Referenced by sua_addr_parse_part().

## sua_rx_asp()

static int sua_rx_asp | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References xua_msg_event_map::event, osmo_ss7_asp::fi, SUA_ERR_UNSUPP_MSG_TYPE, and xua_msg_event_map().

Referenced by sua_rx_msg().

## sua_rx_cl()

static int sua_rx_cl | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References xua_msg::hdr, osmo_ss7_asp::inst, xua_common_hdr::msg_class, xua_common_hdr::msg_type, osmo_ss7_instance::sccp, scrc_rx_mtp_xfer_ind_xua(), SUA_CL_CLDR, SUA_CL_CLDT, SUA_ERR_UNSUPP_MSG_TYPE, and SUA_MSGC_CL.

Referenced by sua_rx_msg().

## sua_rx_co()

static int sua_rx_co | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References xua_msg::hdr, osmo_ss7_asp::inst, xua_common_hdr::msg_class, xua_common_hdr::msg_type, osmo_ss7_instance::sccp, scrc_rx_mtp_xfer_ind_xua(), SUA_CO_COAK, SUA_CO_CODA, SUA_CO_CODT, SUA_CO_COERR, SUA_CO_COIT, SUA_CO_CORE, SUA_CO_COREF, SUA_CO_RELCO, SUA_CO_RELRE, SUA_CO_RESCO, SUA_CO_RESRE, SUA_ERR_UNSUPP_MSG_TYPE, and SUA_MSGC_CO.

Referenced by sua_rx_msg().

## sua_rx_mgmt()

static int sua_rx_mgmt | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References xua_msg::hdr, xua_common_hdr::msg_type, SUA_ERR_UNSUPP_MSG_TYPE, SUA_MGMT_ERR, SUA_MGMT_NTFY, sua_rx_mgmt_err(), and sua_rx_mgmt_ntfy().

Referenced by sua_rx_msg().

## sua_rx_mgmt_err()

static int sua_rx_mgmt_err | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References LOGPASP, m3ua_err_names, SUA_IEI_ERR_CODE, xua_msg_dump(), and xua_msg_get_u32().

Referenced by sua_rx_mgmt().

## sua_rx_mgmt_ntfy()

static int sua_rx_mgmt_ntfy | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References osmo_xlm_prim_notify::info_string, LOGPASP, m3ua_decode_notify(), M3UA_NOTIFY_T_OTHER, M3UA_NOTIFY_T_STATCHG, m3ua_ntfy_other_names, m3ua_ntfy_stchg_names, m3ua_ntfy_type_names, osmo_xlm_prim_notify::status_info, and osmo_xlm_prim_notify::status_type.

Referenced by sua_rx_mgmt().

## sua_rx_msg()

int sua_rx_msg | ( | struct osmo_ss7_asp * | asp,
|  | struct msgb * | msg
| ) |  |

process SUA message received from socket

Parameters

  [in] | asp | Application Server Process receiving msg
  [in] | msg | received message buffer

Returns
  0 on success; negative on error

References osmo_ss7_asp::cfg, xua_common_hdr::data, osmo_mtp_transfer_param::dpc, xua_msg::hdr, osmo_ss7_asp::inst, LOGPASP, xua_common_hdr::msg_class, xua_msg::mtp, MTP_SI_SCCP, osmo_mtp_transfer_param::opc, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp::proto, osmo_ss7_instance::sccp, osmo_mtp_transfer_param::sio, SUA_ERR_INVAL_STREAM_ID, SUA_ERR_INVALID_VERSION, SUA_ERR_MISSING_PARAM, SUA_ERR_PARAM_FIELD_ERR, SUA_ERR_UNSUPP_MSG_CLASS, sua_gen_error_msg(), SUA_MSGC_ASPSM, SUA_MSGC_ASPTM, SUA_MSGC_CL, SUA_MSGC_CO, SUA_MSGC_MGMT, SUA_MSGC_RKM, SUA_MSGC_SNM, sua_rx_asp(), sua_rx_cl(), sua_rx_co(), sua_rx_mgmt(), sua_tx_xua_asp(), SUA_VERSION, xua_common_hdr::version, xua_dialect_check_all_mand_ies(), xua_from_msg(), xua_hdr_dump(), and xua_msg_free().

Referenced by xua_cli_read_cb(), and xua_srv_conn_cb().

## sua_to_msg()

static struct msgb* sua_to_msg | ( | struct xua_msg * | xua | ) |

static

References xua_msg::hdr, xua_common_hdr::msg_class, SUA_MSGC_CL, SUA_MSGC_CO, SUA_PPID, SUA_VERSION, and xua_to_msg().

Referenced by sua_tx_xua_as(), and sua_tx_xua_asp().

## sua_tx_xua_as()

int sua_tx_xua_as | ( | struct osmo_ss7_as * | as,
|  | struct xua_msg * | xua
| ) |  |

Send a given xUA message via a given SUA Application Server.

Parameters

  [in] | as | Application Server through which to send xua
  [in] | xua | xUA message to be sent

Returns
  0 on success; negative on error

References osmo_ss7_as::cfg, osmo_ss7_routing_key::context, osmo_ss7_as::fi, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_as::proto, osmo_ss7_as::routing_key, SUA_IEI_ROUTE_CTX, sua_to_msg(), XUA_AS_E_TRANSFER_REQ, and xua_msg_add_u32().

Referenced by gen_mtp_transfer_req_xua().

## sua_tx_xua_asp()

static int sua_tx_xua_asp | ( | struct osmo_ss7_asp * | asp,
|  | struct xua_msg * | xua
| ) |  |

static

References osmo_ss7_asp::cfg, OSMO_SS7_ASP_PROT_SUA, osmo_ss7_asp_send(), osmo_ss7_asp::proto, and sua_to_msg().

Referenced by sua_rx_msg().

## Variable Documentation

## cldr_mand_ies

const uint16_t cldr_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_CAUSE, SUA_IEI_SRC_ADDR,
SUA_IEI_DEST_ADDR, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_ADDR
#define SUA_IEI_SRC_ADDR
Definition: sua.h:98
SUA_IEI_DEST_ADDR
#define SUA_IEI_DEST_ADDR
Definition: sua.h:99
SUA_IEI_CAUSE
#define SUA_IEI_CAUSE
Definition: sua.h:102

## cldt_mand_ies

const uint16_t cldt_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_PROTO_CLASS, SUA_IEI_SRC_ADDR,
SUA_IEI_DEST_ADDR, SUA_IEI_SEQ_CTRL, SUA_IEI_DATA, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_ADDR
#define SUA_IEI_SRC_ADDR
Definition: sua.h:98
SUA_IEI_DATA
#define SUA_IEI_DATA
Definition: sua.h:107
SUA_IEI_PROTO_CLASS
#define SUA_IEI_PROTO_CLASS
Definition: sua.h:116
SUA_IEI_DEST_ADDR
#define SUA_IEI_DEST_ADDR
Definition: sua.h:99
SUA_IEI_SEQ_CTRL
#define SUA_IEI_SEQ_CTRL
Definition: sua.h:117

## coak_mand_ies

const uint16_t coak_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_PROTO_CLASS, SUA_IEI_DEST_REF,
SUA_IEI_SRC_REF, SUA_IEI_SEQ_CTRL, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_PROTO_CLASS
#define SUA_IEI_PROTO_CLASS
Definition: sua.h:116
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101
SUA_IEI_SEQ_CTRL
#define SUA_IEI_SEQ_CTRL
Definition: sua.h:117

## coda_mand_ies

const uint16_t coda_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101

## codt_mand_ies

const uint16_t codt_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_DATA, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_DATA
#define SUA_IEI_DATA
Definition: sua.h:107
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101

## coerr_mand_ies

const uint16_t coerr_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_CAUSE, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101
SUA_IEI_CAUSE
#define SUA_IEI_CAUSE
Definition: sua.h:102

## coit_mand_ies

const uint16_t coit_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_PROTO_CLASS, SUA_IEI_SRC_REF,
SUA_IEI_DEST_REF, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_PROTO_CLASS
#define SUA_IEI_PROTO_CLASS
Definition: sua.h:116
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101

## core_mand_ies

const uint16_t core_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_PROTO_CLASS, SUA_IEI_SRC_REF,
SUA_IEI_DEST_ADDR, SUA_IEI_SEQ_CTRL, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_PROTO_CLASS
#define SUA_IEI_PROTO_CLASS
Definition: sua.h:116
SUA_IEI_DEST_ADDR
#define SUA_IEI_DEST_ADDR
Definition: sua.h:99
SUA_IEI_SEQ_CTRL
#define SUA_IEI_SEQ_CTRL
Definition: sua.h:117

## coref_mand_ies

const uint16_t coref_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_CAUSE, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101
SUA_IEI_CAUSE
#define SUA_IEI_CAUSE
Definition: sua.h:102

## msg_class_cl

const struct xua_msg_class msg_class_cl

static

Initial value:
= {
.name = "CL",
.msgt_names = sua_cl_msgt_names,
.iei_names = sua_iei_names,
.mand_ies = {
MAND_IES(SUA_CL_CLDT, cldt_mand_ies),
MAND_IES(SUA_CL_CLDR, cldr_mand_ies),
},
}
SUA_CL_CLDR
#define SUA_CL_CLDR
Definition: sua.h:68
sua_cl_msgt_names
static const struct value_string sua_cl_msgt_names[]
Definition: sua.c:129
cldt_mand_ies
static const uint16_t cldt_mand_ies[]
Definition: sua.c:121
MAND_IES
#define MAND_IES(msgt, ies)
Definition: sua.c:119
sua_iei_names
static const struct value_string sua_iei_names[]
Definition: sua.c:80
cldr_mand_ies
static const uint16_t cldr_mand_ies[]
Definition: sua.c:125
SUA_CL_CLDT
#define SUA_CL_CLDT
Definition: sua.h:67

## msg_class_co

const struct xua_msg_class msg_class_co

static

Initial value:
= {
.name = "CO",
.msgt_names = sua_co_msgt_names,
.iei_names = sua_iei_names,
.mand_ies = {
MAND_IES(SUA_CO_CODT, codt_mand_ies),
MAND_IES(SUA_CO_CODA, coda_mand_ies),
MAND_IES(SUA_CO_CORE, core_mand_ies),
MAND_IES(SUA_CO_COAK, coak_mand_ies),
MAND_IES(SUA_CO_COREF, coref_mand_ies),
MAND_IES(SUA_CO_RELRE, relre_mand_ies),
MAND_IES(SUA_CO_RELCO, relco_mand_ies),
MAND_IES(SUA_CO_RESRE, resre_mand_ies),
MAND_IES(SUA_CO_RESCO, resco_mand_ies),
MAND_IES(SUA_CO_COERR, coerr_mand_ies),
MAND_IES(SUA_CO_COIT, coit_mand_ies),
},
}
coref_mand_ies
static const uint16_t coref_mand_ies[]
Definition: sua.c:158
SUA_CO_RELCO
#define SUA_CO_RELCO
Definition: sua.h:74
SUA_CO_CODT
#define SUA_CO_CODT
Definition: sua.h:77
SUA_CO_RESCO
#define SUA_CO_RESCO
Definition: sua.h:75
resco_mand_ies
static const uint16_t resco_mand_ies[]
Definition: sua.c:172
SUA_CO_RESRE
#define SUA_CO_RESRE
Definition: sua.h:76
core_mand_ies
static const uint16_t core_mand_ies[]
Definition: sua.c:150
SUA_CO_COREF
#define SUA_CO_COREF
Definition: sua.h:72
resre_mand_ies
static const uint16_t resre_mand_ies[]
Definition: sua.c:168
SUA_CO_RELRE
#define SUA_CO_RELRE
Definition: sua.h:73
SUA_CO_CODA
#define SUA_CO_CODA
Definition: sua.h:78
codt_mand_ies
static const uint16_t codt_mand_ies[]
Definition: sua.c:144
relre_mand_ies
static const uint16_t relre_mand_ies[]
Definition: sua.c:161
MAND_IES
#define MAND_IES(msgt, ies)
Definition: sua.c:119
SUA_CO_COAK
#define SUA_CO_COAK
Definition: sua.h:71
sua_iei_names
static const struct value_string sua_iei_names[]
Definition: sua.c:80
sua_co_msgt_names
static const struct value_string sua_co_msgt_names[]
Definition: sua.c:182
coak_mand_ies
static const uint16_t coak_mand_ies[]
Definition: sua.c:154
SUA_CO_COIT
#define SUA_CO_COIT
Definition: sua.h:80
SUA_CO_CORE
#define SUA_CO_CORE
Definition: sua.h:70
coerr_mand_ies
static const uint16_t coerr_mand_ies[]
Definition: sua.c:175
relco_mand_ies
static const uint16_t relco_mand_ies[]
Definition: sua.c:165
coda_mand_ies
static const uint16_t coda_mand_ies[]
Definition: sua.c:147
SUA_CO_COERR
#define SUA_CO_COERR
Definition: sua.h:79
coit_mand_ies
static const uint16_t coit_mand_ies[]
Definition: sua.c:178

## relco_mand_ies

const uint16_t relco_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_SRC_REF, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101

## relre_mand_ies

const uint16_t relre_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_SRC_REF,
SUA_IEI_CAUSE, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101
SUA_IEI_CAUSE
#define SUA_IEI_CAUSE
Definition: sua.h:102

## resco_mand_ies

const uint16_t resco_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_SRC_REF, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101

## resre_mand_ies

const uint16_t resre_mand_ies[]

static

Initial value:
= {
SUA_IEI_ROUTE_CTX, SUA_IEI_DEST_REF, SUA_IEI_SRC_REF,
SUA_IEI_CAUSE, 0
}
SUA_IEI_ROUTE_CTX
#define SUA_IEI_ROUTE_CTX
Definition: sua.h:83
SUA_IEI_SRC_REF
#define SUA_IEI_SRC_REF
Definition: sua.h:100
SUA_IEI_DEST_REF
#define SUA_IEI_DEST_REF
Definition: sua.h:101
SUA_IEI_CAUSE
#define SUA_IEI_CAUSE
Definition: sua.h:102

## sua_aspxm_map

const struct xua_msg_event_map sua_aspxm_map[]

static

Initial value:
= {
{ SUA_MSGC_ASPSM, SUA_ASPSM_UP, XUA_ASP_E_ASPSM_ASPUP },
{ SUA_MSGC_ASPSM, SUA_ASPSM_DOWN, XUA_ASP_E_ASPSM_ASPDN },
{ SUA_MSGC_ASPSM, SUA_ASPSM_BEAT, XUA_ASP_E_ASPSM_BEAT },
{ SUA_MSGC_ASPSM, SUA_ASPSM_UP_ACK, XUA_ASP_E_ASPSM_ASPUP_ACK },
{ SUA_MSGC_ASPSM, SUA_ASPSM_DOWN_ACK, XUA_ASP_E_ASPSM_ASPDN_ACK },
{ SUA_MSGC_ASPSM, SUA_ASPSM_BEAT_ACK, XUA_ASP_E_ASPSM_BEAT_ACK },
{ SUA_MSGC_ASPTM, SUA_ASPTM_ACTIVE, XUA_ASP_E_ASPTM_ASPAC },
{ SUA_MSGC_ASPTM, SUA_ASPTM_INACTIVE, XUA_ASP_E_ASPTM_ASPIA },
{ SUA_MSGC_ASPTM, SUA_ASPTM_ACTIVE_ACK, XUA_ASP_E_ASPTM_ASPAC_ACK },
{ SUA_MSGC_ASPTM, SUA_ASPTM_INACTIVE_ACK, XUA_ASP_E_ASPTM_ASPIA_ACK },
}
XUA_ASP_E_ASPSM_ASPDN
Definition: xua_asp_fsm.h:23
XUA_ASP_E_ASPSM_BEAT
Definition: xua_asp_fsm.h:28
SUA_ASPTM_INACTIVE_ACK
#define SUA_ASPTM_INACTIVE_ACK
Definition: sua.h:60
SUA_ASPSM_DOWN
#define SUA_ASPSM_DOWN
Definition: sua.h:51
SUA_ASPSM_BEAT
#define SUA_ASPSM_BEAT
Definition: sua.h:52
XUA_ASP_E_ASPTM_ASPIA_ACK
Definition: xua_asp_fsm.h:26
SUA_ASPTM_ACTIVE
#define SUA_ASPTM_ACTIVE
Definition: sua.h:57
SUA_ASPTM_INACTIVE
#define SUA_ASPTM_INACTIVE
Definition: sua.h:58
XUA_ASP_E_ASPSM_ASPUP
Definition: xua_asp_fsm.h:19
SUA_ASPSM_DOWN_ACK
#define SUA_ASPSM_DOWN_ACK
Definition: sua.h:54
SUA_ASPSM_BEAT_ACK
#define SUA_ASPSM_BEAT_ACK
Definition: sua.h:55
SUA_ASPSM_UP
#define SUA_ASPSM_UP
Definition: sua.h:50
XUA_ASP_E_ASPTM_ASPAC_ACK
Definition: xua_asp_fsm.h:22
SUA_MSGC_ASPTM
#define SUA_MSGC_ASPTM
Definition: sua.h:34
XUA_ASP_E_ASPSM_ASPDN_ACK
Definition: xua_asp_fsm.h:24
XUA_ASP_E_ASPTM_ASPIA
Definition: xua_asp_fsm.h:25
SUA_ASPTM_ACTIVE_ACK
#define SUA_ASPTM_ACTIVE_ACK
Definition: sua.h:59
SUA_ASPSM_UP_ACK
#define SUA_ASPSM_UP_ACK
Definition: sua.h:53
SUA_MSGC_ASPSM
#define SUA_MSGC_ASPSM
Definition: sua.h:33
XUA_ASP_E_ASPSM_ASPUP_ACK
Definition: xua_asp_fsm.h:20
XUA_ASP_E_ASPTM_ASPAC
Definition: xua_asp_fsm.h:21
XUA_ASP_E_ASPSM_BEAT_ACK
Definition: xua_asp_fsm.h:29

## sua_cl_msgt_names

const struct value_string sua_cl_msgt_names[]

static

Initial value:
= {
{ SUA_CL_CLDT, "CLDT" },
{ SUA_CL_CLDR, "CLDR" },
{ 0, NULL }
}
SUA_CL_CLDR
#define SUA_CL_CLDR
Definition: sua.h:68
SUA_CL_CLDT
#define SUA_CL_CLDT
Definition: sua.h:67

## sua_co_msgt_names

const struct value_string sua_co_msgt_names[]

static

Initial value:
= {
{ SUA_CO_CODT, "CODT" },
{ SUA_CO_CODA, "CODA" },
{ SUA_CO_CORE, "CORE" },
{ SUA_CO_COAK, "COAK" },
{ SUA_CO_COREF, "COREF" },
{ SUA_CO_RELRE, "RELRE" },
{ SUA_CO_RELCO, "RELCO" },
{ SUA_CO_RESRE, "RESRE" },
{ SUA_CO_RESCO, "RESCO" },
{ SUA_CO_COERR, "COERR" },
{ SUA_CO_COIT, "COIT" },
{ 0, NULL }
}
SUA_CO_RELCO
#define SUA_CO_RELCO
Definition: sua.h:74
SUA_CO_CODT
#define SUA_CO_CODT
Definition: sua.h:77
SUA_CO_RESCO
#define SUA_CO_RESCO
Definition: sua.h:75
SUA_CO_RESRE
#define SUA_CO_RESRE
Definition: sua.h:76
SUA_CO_COREF
#define SUA_CO_COREF
Definition: sua.h:72
SUA_CO_RELRE
#define SUA_CO_RELRE
Definition: sua.h:73
SUA_CO_CODA
#define SUA_CO_CODA
Definition: sua.h:78
SUA_CO_COAK
#define SUA_CO_COAK
Definition: sua.h:71
SUA_CO_COIT
#define SUA_CO_COIT
Definition: sua.h:80
SUA_CO_CORE
#define SUA_CO_CORE
Definition: sua.h:70
SUA_CO_COERR
#define SUA_CO_COERR
Definition: sua.h:79

## sua_iei_names

const struct value_string sua_iei_names[]

static

## xua_dialect_sua

const struct xua_dialect xua_dialect_sua

Initial value:
= {
.name = "SUA",
.ppid = SUA_PPID,
.port = SUA_PORT,
.log_subsys = DLSUA,
.class = {
[SUA_MSGC_MGMT] = &m3ua_msg_class_mgmt,
[SUA_MSGC_SNM] = &m3ua_msg_class_snm,
[SUA_MSGC_ASPSM] = &m3ua_msg_class_aspsm,
[SUA_MSGC_ASPTM] = &m3ua_msg_class_asptm,
[SUA_MSGC_CL] = &msg_class_cl,
[SUA_MSGC_CO] = &msg_class_co,
[SUA_MSGC_RKM] = &m3ua_msg_class_rkm,
},
}
m3ua_msg_class_rkm
const struct xua_msg_class m3ua_msg_class_rkm
Definition: m3ua.c:259
m3ua_msg_class_aspsm
const struct xua_msg_class m3ua_msg_class_aspsm
Definition: m3ua.c:198
m3ua_msg_class_mgmt
const struct xua_msg_class m3ua_msg_class_mgmt
Definition: m3ua.c:229
SUA_MSGC_CO
#define SUA_MSGC_CO
Definition: sua.h:36
msg_class_cl
static const struct xua_msg_class msg_class_cl
Definition: sua.c:134
SUA_MSGC_SNM
#define SUA_MSGC_SNM
Definition: sua.h:32
m3ua_msg_class_asptm
const struct xua_msg_class m3ua_msg_class_asptm
Definition: m3ua.c:211
SUA_MSGC_CL
#define SUA_MSGC_CL
Definition: sua.h:35
SUA_MSGC_RKM
#define SUA_MSGC_RKM
Definition: sua.h:37
m3ua_msg_class_snm
const struct xua_msg_class m3ua_msg_class_snm
Definition: m3ua.c:175
SUA_PORT
#define SUA_PORT
Definition: sua.h:28
SUA_PPID
#define SUA_PPID
Definition: sua.h:27
SUA_MSGC_ASPTM
#define SUA_MSGC_ASPTM
Definition: sua.h:34
msg_class_co
static const struct xua_msg_class msg_class_co
Definition: sua.c:196
SUA_MSGC_MGMT
#define SUA_MSGC_MGMT
Definition: sua.h:31
SUA_MSGC_ASPSM
#define SUA_MSGC_ASPSM
Definition: sua.h:33

Referenced by osmo_sua_to_sccp(), sccp_find_user(), sccp_sclc_rx_from_scrc(), sccp_scoc_rx_from_scrc(), sccp_scoc_rx_inval_opc(), sccp_scoc_rx_inval_src_ref(), sccp_scoc_rx_unass_local_ref(), sccp_scrc_rx_sclc_msg(), sccp_scrc_rx_scoc_conn_msg(), and scrc_rx_mtp_xfer_ind_xua().